<?php

function get_field($project, $field, $id) {
    global $dbname;
    global $dbid;

    $string = "select * from $project where id = $id";

    if (($fields = mysql_db_query("$dbname", "$string", "$dbid")) == FALSE)
        show_error();

    $row = mysql_fetch_array($fields);
        
    return $row["$field"];
}

function clean_exit() {
    global $dbid;
    global $tidings_version;
    global $footer;

    if (isset($dbid) && $dbid != 0) {
        mysql_close($dbid);
    }
    
    echo "\n<!-- $tidings_version -->\n";
    include("$footer");
    exit();
}

function show_error() {
    echo "<p>Error " .mysql_errno() .": " .mysql_error() ."</p><br />";

    clean_exit();
}

function check_valid_project($project) {
    global $dbname, $dbid;
    global $news_url, $news_home;

    $have_project = 0;

    if (($result = mysql_list_tables("$dbname", "$dbid")) == 0) {
        show_error();
    }

    for ($i = 0; $i < mysql_num_rows($result); $i++) {
        if (strcmp("$project", mysql_tablename($result, $i)) != 0)
	    continue;
	else {
	    $have_project = 1;
	    break;
	}
    }

    mysql_free_result($result);

    if ($have_project != 1) {
        include("$news_home/include/strings.inc");
        echo "$invalid_project\n";

        return 1;
    }

    return 0;
}

function check_valid_mode($mode) {
    global $valid_modes, $news_home;

    $have_mode = 0;

    for ($i = 0; $i < count($valid_modes); $i++) {
        if (strcmp("$mode", $valid_modes[$i]) != 0) {
	    continue;
	}
	else {
	    $have_mode = 1;
	    break;
	}
    }

    if ($have_mode != 1) {
        include("$news_home/include/strings.inc");
        echo "$invalid_mode\n";
	clean_exit();
    }

    return 0;
}

function field_markup($row, $line, $project, $mode) {
    global $news_url, $news_home;
    global $admin_news_url;
    global $version, $content, $update, $do_update;
    static $form_hit = 0;
    global $project_desc, $table, $project_name, $have_project;
    global $prev, $next, $total;

    include("$news_home/include/strings.inc");

    if (ereg("\\^TITLE\\^", "$line")) {
        if ($mode == "display") {
	    $string = "<a class=\"$display_anchor_class\" ";
	    $string = $string . "href=\"$news_url?project=$project&amp;mode=read\">";
	    $string = $string . $row["title"] . "</a>";
            $s = ereg_replace("\\^TITLE\\^", $string, "$line");
	}
	else
            $s = ereg_replace("\\^TITLE\\^", $row["title"], "$line");
    }
    elseif (ereg("\\^FORM\\^", "$line")) {
        $s = "<form action=\"$admin_news_url\" method=\"get\">";
    }
    elseif (ereg("\\^TABLENAME\\^", "$line")) {
        $s = ereg_replace("\\^TABLENAME\\^", "$project", "$line");
    }
    elseif (ereg("\\^OPTION\\^", "$line")) {
        if ($mode == "option") {
	    if (isset($have_project))
	        $s = "<option value=\"$project\">" . $row["title"];
	    else
	        $s = "<option value=\"\">";
	}
    }
    elseif (ereg("\\^INPUT\\^", "$line")) {
        if ($mode == "modify") {
	    if (isset($do_update) == FALSE || $do_update == 0) {
	        $s = "<input type=\"radio\" name=\"id\" value=\"" . $row["id"];
	        $s = "$s" . "\" />";
	    }
	    else {
	        $s = "<input type=\"text\" name=\"version\" value=\"";
		$s = "$s" . $row["version"] . "\" /> ";
                $s = "$s" . "<input type=\"hidden\" name=\"update\" ";
    	        $s = "$s" . "value=\"1\" />";
	        $s = "$s" . "<input type=\"hidden\" name=\"id\" ";
	        $s = "$s" . "value=\"" . $row["id"] . "\" />";
	    }

	    if ($form_hit == 0) {
	        $s = "$s" . "<input type=\"hidden\" name=\"mode\" value=\"";
		$s = "$s" . "modify\" />";
	        $s = "$s" . "<input type=\"hidden\" name=\"project\" ";
	        $s = "$s" . "value=\"$project\" />";
		$s = "$s" . "<input type=\"hidden\" name=\"do_update\" ";
		$s = "$s" . "value=\"1\" />";

	        $form_hit = 1;
	    }
	}
	elseif ($mode == "delete") {
	    $s = "<input type=\"checkbox\" name=\"id[]\" value=\"";
	    $s = "$s" . $row["id"] . "\" />";

	    if ($form_hit == 0) {
	    $s = "$s" . "<input type=\"hidden\" name=\"mode\" ";
	    $s = "$s" . "VALUE=\"delete\" />";
	    $s = "$s" . "<input type=\"hidden\" name=\"project\" ";
	    $s = "$s" . "value=\"$project\" />";

	    $form_hit = 1;
	    }
	}
	elseif ($mode == "add") {
            $s = "<input type=\"text\" name=\"version\" size=\"15\" ";
	    $s = "$s" . "value=\"$version\" />\n";
	    $s = "$s" . "<input type=\"hidden\" name=\"mode\" ";
	    $s = "$s" . "value=\"Add\" />";
	    $s = "$s" . "<input type=\"hidden\" name=\"project\" ";
	    $s = "$s" . "value=\"$project\" />";
	}
    }
    elseif (ereg("\\^ENTRYSTAMP\\^", "$line")) {
        $s = ereg_replace("\\^ENTRYSTAMP\\^", $row["entrystamp"], "$line");
    }
    elseif (ereg("\\^ID\\^", "$line")) {
        $s = ereg_replace("\\^ID\\^", $row["id"], "$line");
    }
    elseif (ereg("\\^VERSION\\^", "$line")) {
        $s = ereg_replace("\\^VERSION\\^", $row["version"], "$line");
    }
    elseif (ereg("\\^DESCRIPTION\\^", "$line")) {
        $s = ereg_replace("\\^DESCRIPTION\\^", $row["description"], "$line");
    }
    elseif (ereg("\\^NEXTPAGE\\^", "$line")) {
        if(isset($total)) {
	    if ($next >= 2) {
                $s = "<a class=\"$page_class\" ";
	        $s = "$s" . "href=\"$news_url?project=$project&amp;mode=read&amp;";
 	        $s = "$s" . "jump=$next\">$next_markup</a>";
            }
	    else 
	        $s = "";
	}
	else
	    $s = "";
    }
    elseif (ereg("\\^PREVPAGE\\^", "$line")) {
        if (isset($total)) {
            if ($prev <= $total + 1) {
                $s = "<a class=\"$page_class\" ";
	        $s = "$s" . "href=\"$news_url?project=$project&amp;mode=read&amp;";
 	        $s = "$s" . "jump=$prev\">$prev_markup</a>";
	    }
	    else 
	        $s = "";
	}
	else
	    $s = "";
    }
    elseif (ereg("\\^CONTENT\\^", "$line")) {
        if ($mode == "add")
            $s = ereg_replace("\\^CONTENT\\^", "$content", "$line");
	else
            $s = ereg_replace("\\^CONTENT\\^", $row["content"], "$line");
    }
    else 
	$s = "$line";

    return "$s";
}

function read_file($row, $project, $mode, $fp) {
    static $start_pos = 0;
    global $end_pos;

    while (($s = fgets($fp, 1024))) {
        if (ereg("^\\^+LOOP+_+BEGIN+\\^", "$s")) {
	    $start_pos = ftell($fp);
	    continue;
	}
	elseif (ereg("^\\^+LOOP+_+END+\\^", "$s")) {
	    $end_pos = ftell($fp);
	    break;
	}
	else {
	    echo field_markup($row, $s, $project, $mode);
	}
    }

    fseek($fp, $start_pos);

    return;
}

?>
